//***************************************************************************
//
//***************************************************************************
void LCD_Init(void);
void LCD_Write_String(uint8 Row, uint8 Col, char *s);
void LCD_CLS(void);
void LCD_Erase_Line(uint8 Row);

static void LCD_Write_Char(uint8 Row, uint8 Col, uint8 Data);
static void LCD_EN_PULSE(void);
static void LCD_Check(void);
static void LCD_Write(uint8 Data, uint8 Type);
static void LCD_Set_Position(uint8 Row, uint8 Col);
static void Write_CGRAM(void);
//***************************************************************************



//***************************************************************************
//IOĴ˿ڡ
//***************************************************************************
#define LCD_DDR_EN DDRC
#define LCD_DDR_RW DDRC
#define LCD_DDR_RS DDRC
#define LCD_DDR_DATA DDRD


#define LCD_PORT_EN PORTC
#define LCD_PORT_RW PORTC
#define LCD_PORT_RS PORTC
#define LCD_PORT_DATA PORTD


#define LCD_LINE_D1 PD4	//MPU-Pin06<---->LCD-Pin11
#define LCD_LINE_D2 PD5	//MPU-Pin11<---->LCD-Pin12
#define LCD_LINE_D3 PD6	//MPU-Pin12<---->LCD-Pin13
#define LCD_LINE_D4 PD7	//MPU-Pin13<---->LCD-Pin14

#define LCD_LINE_RS	PC0	//MPU-Pin23<---->LCD-Pin04
#define LCD_LINE_RW	PC1	//MPU-Pin24<---->LCD-Pin05
#define LCD_LINE_EN	PC2	//MPU-Pin25<---->LCD-Pin06
//***************************************************************************



//***************************************************************************
//ʹܸơ
//***************************************************************************
#define LCD_LINE_EN_OUT	LCD_DDR_EN |= (1<<LCD_LINE_EN)
#define LCD_LINE_RW_OUT	LCD_DDR_RW |= (1<<LCD_LINE_RW)
#define LCD_LINE_RS_OUT	LCD_DDR_RS |= (1<<LCD_LINE_RS)

#define LCD_PORT_DATA_OUT	LCD_DDR_DATA |=((1<<LCD_LINE_D1)|(1<<LCD_LINE_D2)|(1<<LCD_LINE_D3)|(1<<LCD_LINE_D4))
#define LCD_PORT_DATA_IN	LCD_DDR_DATA &= ~((1<<LCD_LINE_D1)|(1<<LCD_LINE_D2)|(1<<LCD_LINE_D3)|(1<<LCD_LINE_D4))



//***************************************************************************
//ߵƽ״̬
//***************************************************************************
#define LCD_RS_H LCD_PORT_RS |= (1<<LCD_LINE_RS)
#define LCD_RS_L LCD_PORT_RS &= ~(1<<LCD_LINE_RS)

#define LCD_EN_H LCD_PORT_EN |= (1<<LCD_LINE_EN)
#define LCD_EN_L LCD_PORT_EN &= ~(1<<LCD_LINE_EN)

#define LCD_RW_H LCD_PORT_RW |= (1<<LCD_LINE_RW)
#define LCD_RW_L LCD_PORT_RW &= ~(1<<LCD_LINE_RW)
//***************************************************************************